//
// Copyright (C) 2006 Henning Westerholt
// Copyright (C) 2005 Andras Varga
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//

// adapted from IPControlInfo.h

#ifndef __TDMACONTROLINFO_H
#define __TDMACONTROLINFO_H

#include "TDMAControlInfo_m.h"

class TDMADatagram;

class TDMAControlInfo : public TDMAControlInfo_Base
{
  public:
    TDMAControlInfo() : TDMAControlInfo_Base() { dgram = NULL; }
    virtual ~TDMAControlInfo();
    TDMAControlInfo(const TDMAControlInfo& other) : TDMAControlInfo_Base() { dgram = NULL; operator=(other); }
    TDMAControlInfo& operator=(const TDMAControlInfo& other) {TDMAControlInfo_Base::operator=(other); return *this; }
    virtual void setOrigDatagram(TDMADatagram *d);
    virtual TDMADatagram *removeOrigDatagram();

  protected:
    TDMADatagram * dgram;
};

#endif
